import { PaymentResponseModel } from "gap-nodejs-sdk/dist/clover/payment_response_model";
import { PaymentInput, AdjustInput, VoidInput, RefundInput, RetrieveInput, Order } from "gap-nodejs-sdk/dist/clover/types";
import { PaymentInterface } from "gap-nodejs-sdk/dist/payment/payment_interface";
import { GapPaymentClientConfiguration } from "gap-nodejs-sdk/dist/payment/type";
import { GapMiniAppSdk } from "gap-miniapp-sdk";
export declare class CloverUsbPaymentClient implements PaymentInterface {
    paymentClientConfiguration: GapPaymentClientConfiguration;
    paymentClient: GapMiniAppSdk;
    initializePaymentClient(_client: any): void;
    doAuth(paymentInput: PaymentInput): Promise<PaymentResponseModel>;
    doSale(paymentInput: PaymentInput): Promise<PaymentResponseModel>;
    doAdjust(adjustInput: AdjustInput): Promise<PaymentResponseModel>;
    doVoid(voidInput: VoidInput): Promise<PaymentResponseModel>;
    doRefund(refundInput: RefundInput): Promise<PaymentResponseModel>;
    doBatchClose(): Promise<PaymentResponseModel>;
    doRetrieve(retrieveInput: RetrieveInput): Promise<PaymentResponseModel>;
    cancel(): Promise<boolean>;
    dispose(): Promise<void>;
    doShowDisplayOrder(order: Order): void;
    doRemoveDisplayOrder(order: Order): void;
    getDeviceStatus(): Promise<any>;
    showMessage(message: string): void;
    showWelcomeScreen(): void;
    showThankYouScreen(): void;
}
//# sourceMappingURL=clover-usb-payment-client.d.ts.map