import { __awaiter } from "tslib";
import { GapMiniAppSdk, Platform } from "gap-miniapp-sdk";
import { CloverUsbPaymentResponseModel } from "./clover-usb-payment-response-model";
export class CloverUsbPaymentClient {
    initializePaymentClient(_client) {
        //Example for paymentClientConfiguration:
        // this.paymentClientConfiguration = {
        //     driver: GapPaymentClientDriver.PAX,
        //     configuration: {
        //         platform: "Window",
        //         ip: "192.168.1.1",
        //         port: "9000"
        //     }
        // }
        if (_client instanceof GapMiniAppSdk) {
            this.paymentClient = _client;
        }
        else {
            this.paymentClient = new GapMiniAppSdk();
            this.paymentClient.setPlatformExecutor(Platform.WINDOW);
        }
        this.paymentClient.paymentRequest({ "type": "connect" });
    }
    ;
    doAuth(paymentInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_payment' }, paymentInput));
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, data), { 'type': 'auth' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doSale(paymentInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_payment' }, paymentInput));
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, data), { 'type': 'sale' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doAdjust(adjustInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_adjust' }, adjustInput));
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, data), { 'type': 'adjust' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doVoid(voidInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_void' }, voidInput));
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, data), { 'type': 'void' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doRefund(refundInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_refund' }, refundInput));
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, data), { 'type': 'refund' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doBatchClose() {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest({ type: 'do_batch_close' });
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, data), { 'type': 'batch_close' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doRetrieve(retrieveInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_retrieve' }, retrieveInput));
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, data), { 'type': 'retrieve' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    cancel() {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.paymentClient.paymentRequest({ type: 'do_cancel' });
                resolve(true);
            }
            catch (e) {
                reject(false);
            }
        }));
    }
    ;
    dispose() {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.paymentClient.paymentRequest({ type: 'disconnect' });
                resolve();
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doShowDisplayOrder(order) {
        console.log("Method not implemented on native side");
        console.log(order);
    }
    ;
    doRemoveDisplayOrder(order) {
        console.log("Method not implemented on native side");
        console.log(order);
    }
    ;
    getDeviceStatus() {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest({ type: 'get_status' });
                resolve(data);
            }
            catch (e) {
                resolve({ "deviceConnected": false, "deviceReady": false });
            }
        }));
    }
    ;
    showMessage(message) {
        this.paymentClient.paymentRequest({ type: 'show_message', message });
    }
    ;
    showWelcomeScreen() {
        this.paymentClient.paymentRequest({ type: 'show_welcome_screen' });
    }
    ;
    showThankYouScreen() {
        this.paymentClient.paymentRequest({ type: 'show_thank_you_screen' });
    }
    ;
}
